<template>
	<div
		:id="id"
		class="u-block-spacing u-block-spacing-has-inner u-block-spacing-possibly-touch-previous"
		:class="$style.block"
	>
		<div :class="$style.top">
			<div :class="$style.reviewsInfo">
				<template v-if="powerreviewsPageId">
					<div :class="$style.reviewsInfoName">{{ name }}</div>
					<MoleculeReviewInfo :link="reviewsLink && reviewsLink.url" :page-id="powerreviewsPageId" />
				</template>
			</div>
			<div :class="$style.headingWrapper">
				<h2 :class="$style.heading">{{ heading }}</h2>
			</div>
			<div :class="$style.histogram">
				<div :class="$style.histogramInner">
					<div
						v-for="rating in ratingHistogram"
						:key="rating.number"
						:class="[$style.histogramLine, { [$style.faded]: rating.number < 4 }]"
					>
						<div :class="$style.historamLineNumber">{{ rating.number }} star</div>
						<div :class="$style.histogramLineVisualizationOuter">
							<div :class="$style.histogramLineVisualizationBorder"></div>
							<div :class="$style.histogramLineVisualizationInner" :style="{ width: rating.width }"></div>
						</div>
						<div :class="$style.historamLineLabel">{{ rating.label }}</div>
					</div>
				</div>
			</div>
		</div>
		<div :class="$style.bottom">
			<div :class="[$style.bottomInner, $style.mobile]">
				<MoleculeCarousel :autoplay="false" :has-navigation="false" has-pagination>
					<MoleculeCarouselSlide v-for="(review, index) in reviewsArrayNormalized" :key="index" :slide-index="index">
						<div :class="$style.slideInner">
							<div :class="$style.ratingWrapper">
								<AtomReviewStarsV2 :rating="review.metrics.rating" />
							</div>

							<blockquote :class="$style.quote">
								<p :class="$style.quoteText"> “{{ review.commentsShort || review.details.comments }}” </p>
								<footer :class="$style.quoteFooter">{{ review.details.nickname }}</footer>
							</blockquote>
						</div>
					</MoleculeCarouselSlide>
				</MoleculeCarousel>
			</div>

			<div :class="[$style.bottomInner, $style.desktop]">
				<div v-for="(review, index) in reviewsArrayNormalized" :key="index" :class="$style.column">
					<div :class="$style.ratingWrapper">
						<AtomReviewStarsV2 :rating="review.metrics.rating" />
					</div>

					<blockquote :class="$style.quote">
						<p :class="$style.quoteText"> “{{ review.commentsShort || review.details.comments }}” </p>
						<footer :class="$style.quoteFooter">{{ review.details.nickname }}</footer>
					</blockquote>
				</div>
			</div>

			<div v-if="ctaLink && ctaLink.url" :class="$style.buttonWrapper">
				<BaseButtonArrow :smart="ctaLink.url" :target="ctaLink.target">{{ ctaText }}</BaseButtonArrow>
			</div>
		</div>
	</div>
</template>

<script>
import MoleculeCarousel from '@components/molecule-carousel';
import MoleculeCarouselSlide from '@components/molecule-carousel-slide';
import MoleculeReviewInfo from '@components/molecule-review-info';
import AtomReviewStarsV2 from '@components/atom-review-stars-v2';

export default {
	components: {
		MoleculeReviewInfo,
		AtomReviewStarsV2,
		MoleculeCarousel,
		MoleculeCarouselSlide,
	},

	props: {
		id: {
			type: String,
			default: null,
		},

		reviews: {
			type: Object,
			required: true,
		},

		items: {
			type: Array,
			default: () => [],
		},

		heading: {
			type: String,
			default: '',
		},

		name: {
			type: String,
			default: '',
		},

		powerreviewsPageId: {
			type: String,
			default: '',
		},

		reviewsLink: {
			type: Object,
			default: null,
		},

		ctaText: {
			type: String,
			default: '',
		},

		ctaLink: {
			type: Object,
			default: null,
		},
	},

	computed: {
		reviewsArrayNormalized() {
			const { reviews, items: reviewsPrismic } = this;
			const { truncate } = this.$options.filters;

			if (reviewsPrismic.length > 0) {
				return reviewsPrismic.map((review) => ({
					details: {
						...review,
					},
					metrics: {
						rating: parseInt(review.rating),
					},
				}));
			}

			return reviews.results.slice(0, 3).map((item) => ({
				...item,
				commentsShort: truncate(item.details.comments, 110),
			}));
		},

		ratingHistogram() {
			const { rating_histogram: ratings } = this.reviews.rollup;
			const sum = ratings.reduce((sum, ratings) => sum + ratings, 0);

			return ratings
				.map((rating, index) => {
					const percentage = (rating / sum) * 100;
					return {
						width: `${percentage}%`,
						label: `${Math.round(percentage)}%`,
						number: index + 1,
					};
				})
				.reverse();
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.block {
	color: color('primary-300');
}

.top {
	display: flex;
	flex-direction: column;
	align-items: center;
	justify-content: space-between;
	min-height: 52rem;
	padding: size('s+') size('m-');
	text-align: center;
	background-color: color('secondary-200');

	@include above('medium') {
		min-height: 72rem;
	}
}

.reviewsInfo,
.histogram {
	min-height: 12rem;
}

.reviewsInfoName {
	@include font-family('secondary');
	@include use-text-style('heading-180');

	margin-bottom: size('base');
}

.headingWrapper {
	padding: size('m++') size('base');
}

.heading {
	@include font-family('secondary');
	@include use-text-style('heading-300');

	max-width: 100rem;
	margin: 0 auto;

	@include above('large') {
		@include use-text-style('heading-900');
	}
}

.histogram {
	display: flex;
	align-items: flex-end;
}

.histogramLine {
	display: flex;
	align-items: center;
	font-size: 1.2rem;

	&:not(:last-child) {
		margin-bottom: size('base');
	}

	&.faded {
		color: color('primary-250');
	}
}

.historamLineNumber {
	width: 4.5rem;
}

.histogramLineVisualizationOuter {
	position: relative;
	width: 22rem;
	height: 1rem;
	overflow: hidden;
	border-radius: 0.5rem;
}

.histogramLineVisualizationInner,
.histogramLineVisualizationBorder {
	position: absolute;
	top: 0;
	left: 0;
	height: 100%;
}

.histogramLineVisualizationBorder {
	width: 100%;
	border: 0.1rem solid #969393;
	border-radius: 0.5rem;
}

.histogramLineVisualizationInner {
	background-color: #444;
}

.historamLineLabel {
	width: 3.5rem;
	text-align: right;
}

.bottom {
	padding: 12.5rem size('m+') size('s++');

	@include above('medium') {
		padding: 10rem size('m+') 4.5rem;
	}
}

.bottomInner {
	text-align: center;

	&.mobile {
		margin-bottom: size('m+');

		@include above('medium') {
			display: none;
		}
	}

	&.desktop {
		display: flex;
		justify-content: space-around;
		max-width: 105rem;
		margin: 0 auto size('m++');

		@include below('medium') {
			display: none;
		}
	}
}

.slideInner {
	margin-bottom: size('m+');
}

.ratingWrapper {
	display: flex;
	justify-content: center;
	margin-bottom: size('m+');

	@include above('medium') {
		margin-bottom: size('s');
	}
}

.quote {
	@include use-text-style('type-500');

	font-weight: 300;

	@include above('medium') {
		@include use-text-style('type-100');
	}
}

.quoteText {
	margin-bottom: 1.3em;
}

.column {
	flex: 0 0 auto;
	width: percentage(1 / 3);
	max-width: 30rem;
	padding: 0 size('s');
}

.buttonWrapper {
	display: flex;
	justify-content: center;
}
</style>
